
const int buttonPin[4] = {5,6,7,8};
const int optoPin[2] = {11,10};
const int led1 = 12;
const int led2 = 13;
const int rele1 = 3;
const int rele2 = 4;

int stateMachine = 0;
int counttick = 0;
int tick = 0;
int i = 0;
int buttonState[4] = {0,0,0,0};
int optoState[2] = {0,0};
int temp;

void setup() {
  pinMode(led1, OUTPUT);      
  pinMode(led2, OUTPUT);      
  for (i=0;i<4;i++) {
    pinMode(buttonPin[i], INPUT);
  }
  for (i=0;i<2;i++) {
    pinMode(optoPin[i], INPUT);
  }
  pinMode(rele1, OUTPUT);
  pinMode(rele2, OUTPUT);
  
  Serial.begin(9600);
}

void loop(){
  counttick++;
  delay(1);
  if (counttick == 1000) {
    tick = 1;
    counttick = 0;
  }
  
  if (tick == 1) {
    tick = 0;
    stateMachine++;
    if (stateMachine == 9) {
      stateMachine = 1;
    }
  }
  
  switch (stateMachine) {
    case 0:
    break;
    case 1:
      digitalWrite(rele1, HIGH);
      digitalWrite(led1, HIGH);
      stateMachine++;
    break;
    case 2:
    break; 
    case 3:
      digitalWrite(rele1, LOW);
      digitalWrite(led1, LOW);
      stateMachine++;
    break;
    case 4:
    break;
    case 5:
      digitalWrite(rele2, HIGH);
      digitalWrite(led2, HIGH);
      stateMachine++;
    break;
    case 6:
    break; 
    case 7:
      digitalWrite(rele2, LOW);
      digitalWrite(led2, LOW);
      stateMachine++;
    break;
    case 8:
    break;
  }
    
  for (i=0;i<4;i++) {
    temp = digitalRead(buttonPin[i]);
    if(buttonState[i] != temp) {
      buttonState[i] = temp;
      if(buttonState[i] == 0) {
        Serial.print ("\r\nB");
        Serial.print (i+1, DEC);
      }
    }
  }
    
  for (i=0;i<2;i++) {
    temp = digitalRead(optoPin[i]);
    if(optoState[i] != temp) {
      optoState[i] = temp;
      if(optoState[i] == 0) {
        Serial.print ("\r\nOp");
        Serial.print (i+1, DEC);
      }
    }
  }
  
}
